/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package eventtalkboard;



/**
 *
 * @author hansolo
 */
public class LogoPanel extends javax.swing.JPanel
{
    private String logoFileName = null;
    private java.awt.image.BufferedImage logoImage = null;

    private int newWidth = 230;
    private int newHeight = 140;

    private final java.awt.Color[] BACKGROUND_COLORS =
    {
        new java.awt.Color(0x3E3B32),
        new java.awt.Color(0x232520)
    };

    private final float[] BACKGROUND_FRACTIONS =
    {
        0.0f,
        1.0f
    };

    private final java.awt.geom.Point2D BACKGROUND_START = new java.awt.geom.Point2D.Float(0, 0);
    private final java.awt.geom.Point2D BACKGROUND_STOP = new java.awt.geom.Point2D.Float(0, 140);

    private final java.awt.LinearGradientPaint BACKGROUND_GRADIENT = new java.awt.LinearGradientPaint(BACKGROUND_START, BACKGROUND_STOP, BACKGROUND_FRACTIONS, BACKGROUND_COLORS);
    private final java.awt.geom.Rectangle2D BACKGROUND_RECT = new java.awt.geom.Rectangle2D.Float(0, 0, 230, 140);

    private final java.awt.Color TOP_LIGHT_COLOR = new java.awt.Color(0x000000);
    private final java.awt.Color BOTTOM_LIGHT_COLOR = new java.awt.Color(0x434139);

    private final java.awt.geom.Area LIGHT = new java.awt.geom.Area(new java.awt.geom.RoundRectangle2D.Float(2, 3, 226, 105, 10, 10));
    final private java.awt.Color[] LIGHT_COLORS =
    {
        new java.awt.Color(1.0f, 1.0f, 1.0f, 0.2f),
        new java.awt.Color(1.0f, 1.0f, 1.0f, 0.05f)
    };
    final java.awt.geom.Point2D LIGHT_START = new java.awt.geom.Point2D.Float(0, 3);
    final java.awt.geom.Point2D LIGHT_STOP = new java.awt.geom.Point2D.Float(0, 75);
    final java.awt.LinearGradientPaint LIGHT_GRADIENT = new java.awt.LinearGradientPaint(LIGHT_START, LIGHT_STOP, BACKGROUND_FRACTIONS, LIGHT_COLORS);

    public LogoPanel()
    {
        super();
        setSize(new java.awt.Dimension(230, 140));
        LIGHT.subtract(new java.awt.geom.Area(new java.awt.geom.Ellipse2D.Float(-57, 55, 563, 212)));
        init();
    }

    private void init()
    {
        if (logoFileName != null)
        {
            java.io.File logoFile = new java.io.File(logoFileName);
            if (logoFile.isFile() && logoFile.exists())
            {
                try 
                {
                    this.logoImage = javax.imageio.ImageIO.read(new java.io.File(logoFileName));
                    
                    if(this.logoImage.getWidth() > this.logoImage.getHeight())
                    {
                        double scaleX = (double) (getWidth() - 10) / (double) logoImage.getWidth();
                        newWidth = (int) (logoImage.getWidth() * scaleX);
                        newHeight = (int) (logoImage.getHeight() * scaleX);
                        
                        if (newHeight > getHeight())
                        {
                            double scaleY = (double) (getHeight() - 10) / (double) newHeight;
                            newWidth = (int) (newWidth * scaleY);
                            newHeight = (int) (newHeight * scaleY);
                        }
                    }
                    else
                    {
                        double scaleY = (double) (getHeight() - 10) / (double) logoImage.getHeight();
                        newWidth = (int) (logoImage.getWidth() * scaleY);
                        newHeight = (int) (logoImage.getHeight() * scaleY);
                        
                        if (newWidth > getWidth())
                        {
                            double scaleX = (double) (getWidth() - 10) / (double) newWidth;
                            newWidth = (int) (newWidth * scaleX);
                            newHeight = (int) (newHeight * scaleX);
                        }
                    }
                } 
                catch (java.io.IOException exception) 
                {
                    System.out.println(exception.toString());
                }
            }
        }        
        repaint(0, 0, 230, 140);
    }

    public String getLogoFileName()
    {
        return this.logoFileName;
    }

    public void setLogoFileName(String logoFileName)
    {
        this.logoFileName = logoFileName;
        init();
    }

    @Override
    protected void paintComponent(java.awt.Graphics g)
    {
        if (logoImage != null)
        {
            super.paintComponent(g);
            
            java.awt.Graphics2D g2 = (java.awt.Graphics2D) g;

            g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
            g2.setRenderingHint(java.awt.RenderingHints.KEY_ALPHA_INTERPOLATION, java.awt.RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
            g2.setRenderingHint(java.awt.RenderingHints.KEY_INTERPOLATION, java.awt.RenderingHints.VALUE_INTERPOLATION_BILINEAR);
            g2.setRenderingHint(java.awt.RenderingHints.KEY_COLOR_RENDERING, java.awt.RenderingHints.VALUE_COLOR_RENDER_QUALITY);
            g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);

            g2.setPaint(BACKGROUND_GRADIENT);
            g2.fill(BACKGROUND_RECT);

            g2.setColor(TOP_LIGHT_COLOR);
            g2.drawLine(0, 0, getWidth(), 0);

            g2.setColor(BOTTOM_LIGHT_COLOR);
            g2.drawLine(0, getHeight(), getWidth(), getHeight());
        
            g2.drawImage(logoImage, (getWidth() - newWidth) / 2, (getHeight() - newHeight) / 2, newWidth, newHeight, null);

            g2.setPaint(LIGHT_GRADIENT);
            g2.fill(LIGHT);
        }
    }

    @Override
    public java.awt.Dimension getSize()
    {
        return new java.awt.Dimension(230, 140);
    }

    @Override
    public java.awt.Dimension getSize(java.awt.Dimension dim)
    {
        return super.getSize(new java.awt.Dimension(230, 140));
    }

    @Override
    public int getWidth()
    {
        return 230;
    }

    @Override
    public int getHeight()
    {
        return 140;
    }
}
